import socket
import os
import re

import smtplib

Connect = 'Player'

class Command:

  def __init__(self, host, port):
    self._sfd = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    hostip = socket.gethostbyname(host)
    self._sfd.connect((hostip,port))
    self._log = "" 
    self._sfile = self._sfd.makefile()

  def quit(self):
    self._sfd.close()

  def _sendCommand(self, command):
    try:
      self._sfd.send(command+'\n')
      print 'Sent:',command
    except (IOError, socket.error), e:
      print e
      return 0
    return 1

  def _readResponse(self,title='Server Says:'):
    try:
      response = self._sfile.readline().rstrip()
      print title, response
      self._log += response + '\n' 
      return response
    except (IOError, socket.error), e:
      print e
      return ''

  def get_packages(self):
    packages = []
    pkgline = self._readResponse('Packages Here:')
    if pkgline:
      try:
        pkgdata = map(int, pkgline.split())
        while len(pkgdata) >= 4:
          packages.append(tuple(pkgdata[:4]))
          pkgdata = pkgdata[4:]
      except: pass
    return packages

  def Move(self, move):
    if move:
      return self._sendCommand(move)
    return 0

 
# return as plain text
  def get_response(self):
    return self._readResponse('Update:')

# Grab initial data...
  def read_world(self):
    worldstr = []
    if self._sendCommand(Connect):
      xy = self._readResponse('Map Dimensions:').split()
      if xy:
        for i in range(int(xy[1])):
          mapline = self._readResponse('Map:')
          if mapline:
            worldstr.append(mapline)
    return worldstr

  def read_configuration(self):
    cfg = self._readResponse('Configuration:')
    if cfg:
      return map(int, cfg.split())
    return ''

#Send the log somewhere
  def send_log(self,serv,mto,mfrom):
    try:
      dst = smtplib.SMTP(serv)
      dst.sendmail(mfrom,mto,'To: '+mto+'\r\n'+'From: '+mfrom+'\r\n\r\n'+self._log)
      dst.quit()
    except:
      print 'Could not send log.'
